//-----------------------------------------------------------------------------
#ifndef __polyglot_h__
#define __polyglot_h__
//-----------------------------------------------------------------------------
#include "S3DXAIPackage.h"
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Package declaration
//-----------------------------------------------------------------------------
class polyglotPackage : public S3DX::AIPackage
{
public :

    //-------------------------------------------------------------------------
    //  Constructor / Destructor
	//-------------------------------------------------------------------------

	polyglotPackage         ( ) ;
                               ~polyglotPackage         ( ) ;

	//-------------------------------------------------------------------------
    //  Accessors
	//-------------------------------------------------------------------------

    const   char               *GetName             ( ) const ;
            S3DX::uint32        GetFunctionCount    ( ) const ;
            S3DX::uint32        GetConstantCount    ( ) const ;
    const   S3DX::AIFunction   *GetFunctionAt       ( S3DX::uint32 _iIndex ) const ;
    const   S3DX::AIConstant   *GetConstantAt       ( S3DX::uint32 _iIndex ) const ;

} ;

//-----------------------------------------------------------------------------
// Package API declaration
//-----------------------------------------------------------------------------
class polyglotAPI
{
public :

    //-------------------------------------------------------------------------
    //  API Constructor
	//-------------------------------------------------------------------------
                                polyglotAPI       ( ) 
                                {
                                    pfn_polyglot_init                = NULL ;
                                    pfn_polyglot_isLanguageAvailable = NULL ;
                                    pfn_polyglot_translate           = NULL ;
                                    pfn_polyglot_translateCompound   = NULL ;

                                }

	//-------------------------------------------------------------------------
	//  API Callbacks 
	//-------------------------------------------------------------------------

    S3DX::AICallback        pfn_polyglot_init ;
    S3DX::AICallback        pfn_polyglot_isLanguageAvailable ;
    S3DX::AICallback        pfn_polyglot_translate ;
    S3DX::AICallback        pfn_polyglot_translateCompound ;

	//-------------------------------------------------------------------------
	//  API Functions 
	//-------------------------------------------------------------------------

    inline S3DX::AIVariable     init                ( const S3DX::AIVariable& sXMLpath, const S3DX::AIVariable& sScheme, const S3DX::AIVariable& nVersion ) { S3DX_DECLARE_VIN_03( sXMLpath, sScheme, nVersion ) ; S3DX::AIVariable vOut ; if ( pfn_polyglot_init ) pfn_polyglot_init ( 3, vIn, &vOut ); return vOut ; }
    inline S3DX::AIVariable     isLanguageAvailable ( const S3DX::AIVariable& sLangcode ) { S3DX_DECLARE_VIN_01( sLangcode ) ; S3DX::AIVariable vOut ; if ( pfn_polyglot_isLanguageAvailable ) pfn_polyglot_isLanguageAvailable ( 1, vIn, &vOut ); return vOut ; }
    inline S3DX::AIVariable     translate           ( const S3DX::AIVariable& sLangcode, const S3DX::AIVariable& sPolyglotCode, const S3DX::AIVariable& bLowercase ) { S3DX_DECLARE_VIN_03( sLangcode, sPolyglotCode, bLowercase ) ; S3DX::AIVariable vOut ; if ( pfn_polyglot_translate ) pfn_polyglot_translate ( 3, vIn, &vOut ); return vOut ; }
    inline S3DX::AIVariable     translateCompound   ( const S3DX::AIVariable& sLangcode, const S3DX::AIVariable& sPolyglotCode, const S3DX::AIVariable& bLowercase ) { S3DX_DECLARE_VIN_03( sLangcode, sPolyglotCode, bLowercase ) ; S3DX::AIVariable vOut ; if ( pfn_polyglot_translateCompound ) pfn_polyglot_translateCompound ( 3, vIn, &vOut ); return vOut ; }

 	//-------------------------------------------------------------------------
	//  API Constants 
	//-------------------------------------------------------------------------


} ;

extern polyglotAPI polyglot;

//-----------------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------------
