//-----------------------------------------------------------------------------
#ifndef __Pandora_EngineCore_Unicode_h__
#define __Pandora_EngineCore_Unicode_h__
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
namespace Pandora { namespace EngineCore
//-----------------------------------------------------------------------------
{
    //-------------------------------------------------------------------------
    class PANDORA_ENGINECORE_API Unicode
    //-------------------------------------------------------------------------
    {
    public :

        //---------------------------------------------------------------------
        //  Conversion methods
        //---------------------------------------------------------------------
                static  uint8   UCS2toUTF8          ( const uint16 _iUCS2, uint8  *_pUTF8 ) ;
                static  uint8   UCS4toUTF8          ( const uint32 _iUCS4, uint8  *_pUTF8 ) ;

                static  uint8   UTF8toUCS2          ( const uint8 *_pUTF8, uint16 *_pUCS2 ) ;
                static  uint8   UTF8toUCS4          ( const uint8 *_pUTF8, uint32 *_pUCS4 ) ;
                static  uint16  UTF8toUCS2          ( const uint8 *_pUTF8 ) ;
                static  uint32  UTF8toUCS4          ( const uint8 *_pUTF8 ) ;

        //---------------------------------------------------------------------
        //  Utility methods
        //---------------------------------------------------------------------
        inline  static  uint8   UTF8CharByteCount   ( const uint8 *_pUTF8 ) ;
        inline  static  uint8   UTF8CharByteCount   ( const uint16 _iUCS2 ) ;
        inline  static  uint8   UTF8CharByteCount   ( const uint32 _iUCS4 ) ;

                static  uint32  UTF8StringCharCount ( const uint8 *_pUTF8 ) ;

    private :

        //---------------------------------------------------------------------
        //  Private methods
        //---------------------------------------------------------------------

    //-------------------------------------------------------------------------
    } ;
    //-------------------------------------------------------------------------

//-----------------------------------------------------------------------------
} } // Namespace End
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
#include "Unicode.inl"
//-----------------------------------------------------------------------------
#endif //__Pandora_EngineCore_Unicode_h__
//-----------------------------------------------------------------------------
