//-----------------------------------------------------------------------------
#ifndef __Pandora_EngineCore_Unicode_inl__
#define __Pandora_EngineCore_Unicode_inl__
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
namespace Pandora { namespace EngineCore
//-----------------------------------------------------------------------------
{
    //-------------------------------------------------------------------------
    //  Utility methods
    //-------------------------------------------------------------------------

    inline uint8 Unicode::UTF8CharByteCount ( const uint8 *_pUTF8 )
    {
        const uint8 iFirstByte = _pUTF8[0] ;
        if      (   iFirstByte < 0x00000080     ) return 1 ;
        else if ( ( iFirstByte & 0xE0 ) == 0xC0 ) return 2 ;
        else if ( ( iFirstByte & 0xF0 ) == 0xE0 ) return 3 ;
        else if ( ( iFirstByte & 0xF8 ) == 0xF0 ) return 4 ;
        else if ( ( iFirstByte & 0xFC ) == 0xF8 ) return 5 ;
        else if ( ( iFirstByte & 0xFE ) == 0xFC ) return 6 ;
        else                                      return 0 ; // Not a valid UTF8 sequence...
    }

    //-------------------------------------------------------------------------

    inline uint8 Unicode::UTF8CharByteCount ( const uint16 _iUCS2 )
    {
        if      ( _iUCS2 < 0x00000080 ) return 1 ;
        else if ( _iUCS2 < 0x00000800 ) return 2 ;
        else                            return 3 ;
    }

    //-------------------------------------------------------------------------

    inline uint8 Unicode::UTF8CharByteCount ( const uint32 _iUCS4 )
    {
        if      ( _iUCS4 < 0x00000080 ) return 1 ;
        else if ( _iUCS4 < 0x00000800 ) return 2 ;
        else if ( _iUCS4 < 0x00010000 ) return 3 ;
        else                            return 4 ;
    }



//-----------------------------------------------------------------------------
} } // Namespace End
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
#endif //__Pandora_EngineCore_Unicode_inl__
//-----------------------------------------------------------------------------
